Lionbridge Translation Provider
-------------------------------------

Lionbridge Translation Provider is an external translation service for the 
Translation Management Tool module. It allows users to send content directly 
from their Drupal site into Lionbridge onDemand for professional translation by 
the world's largest translation firm.

Requirements
------------------

Lionbridge Translation Provider was built for Drupal 7 and 8.

To use Translation Management Tool you need to install and activate the
following modules:

 * Translation Management Tool (tmgmt)

Getting started
------------------

The first simple translation job using Microsoft's translation service.

1) Preparation

- Make sure you have downloaded all of the listed dependencies.
- Define a second language using locale
- Modify one content type to be multilingual. Choose 'Enabled, with translation'
  from the Publishing Options / Multilingual support.

2) Create an account with Lionbridge (https://www.lionbridge.com/en-gb/ondemand)

- Contact Lionbridge to start an OnDemand Translation Service account.

3) Set up Translation Management Tool

- Download tmgmt module
- Enable the following modules, this will also include all dependencies
  - Translation Management UI
  - Content translation Source UI
  - Lionbridge translation provider
- Go to the Translator management page at:

    Configuration > Regional and language > Translation Management Translators

  Adjust the label to your liking and get a client ID and client secret using
  the provided link in the settings. Then save the updated translator. Make
  sure that the mapping is completed before saving.

3) Translate

- Create a new piece of content of the multilingual content type defined before.
  Make sure to choose a language.
- Once the node has been saved, click on the "Translate" tab.
- Choose the language you want to translate the node to with the checkbox.
- Click "Request translation".
- Choose the Lionbridge service under "CONFIGURE TRANSLATOR" that was 
created earlier.
- Go to "Job overview" at /admin/tmgmt and click "manage" link for 
job submitted.
- Click "Authorize Quote" to confirm pricing for the translation job.
- Wait a while for the translation job to complete
- Click "Poll translations" to download the translation content.
- Check the content for the translated node!

Features
----------

- Never miss deadlines again – Submit translations 24/7 from anywhere in the 
world and automatically receive a system generated delivery date. 
Lionbridge onDemand consistently delivers early or on-time over 99%+ of time 
against these commitments.
- Automated quoting and due date calculation. Other providers must manually 
inspect multimedia files resulting in delays and higher costs.
- No budget surprises – Automated quotes are provided for every submission and 
spend against your POs can be tracked in real-time.
- No hidden fees – The quotes we provide are fixed quotes with no additional 
charges added after processing.
- No technical issues – Our technical support team will engage with your 
technical team and ensure project success.
- Support from your global teams – Ensure your brand voice is effectively 
applied across all content you translate. We work closely with your teams 
across all languages and geographies to develop linguistic assets that embody 
your brand voice and ensure consistent application across all content types 
and sources.
